/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.ow2.mindEd.adl;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.ow2.mindEd.adl.ComponentReference#getReferenceName <em>Reference Name</em>}</li>
 *   <li>{@link org.ow2.mindEd.adl.ComponentReference#getTemplatesList <em>Templates List</em>}</li>
 *   <li>{@link org.ow2.mindEd.adl.ComponentReference#getArgumentsList <em>Arguments List</em>}</li>
 *   <li>{@link org.ow2.mindEd.adl.ComponentReference#getNameFQN <em>Name FQN</em>}</li>
 *   <li>{@link org.ow2.mindEd.adl.ComponentReference#isResolved <em>Resolved</em>}</li>
 *   <li>{@link org.ow2.mindEd.adl.ComponentReference#getParentReferencesList <em>Parent References List</em>}</li>
 *   <li>{@link org.ow2.mindEd.adl.ComponentReference#getParentSubComponent <em>Parent Sub Component</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.ow2.mindEd.adl.AdlPackage#getComponentReference()
 * @model
 * @generated
 */
public interface ComponentReference extends MergedObject {
	/**
	 * Returns the value of the '<em><b>Reference Name</b></em>' attribute.
	 * The default value is <code>"reference_Name"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Reference Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Reference Name</em>' attribute.
	 * @see #setReferenceName(String)
	 * @see org.ow2.mindEd.adl.AdlPackage#getComponentReference_ReferenceName()
	 * @model default="reference_Name"
	 * @generated
	 */
	String getReferenceName();

	/**
	 * Sets the value of the '{@link org.ow2.mindEd.adl.ComponentReference#getReferenceName <em>Reference Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Reference Name</em>' attribute.
	 * @see #getReferenceName()
	 * @generated
	 */
	void setReferenceName(String value);

	/**
	 * Returns the value of the '<em><b>Templates List</b></em>' containment reference list.
	 * The list contents are of type {@link org.ow2.mindEd.adl.TemplateDefinition}.
	 * It is bidirectional and its opposite is '{@link org.ow2.mindEd.adl.TemplateDefinition#getParentCompositeReference <em>Parent Composite Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Templates List</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Templates List</em>' containment reference list.
	 * @see #isSetTemplatesList()
	 * @see #unsetTemplatesList()
	 * @see org.ow2.mindEd.adl.AdlPackage#getComponentReference_TemplatesList()
	 * @see org.ow2.mindEd.adl.TemplateDefinition#getParentCompositeReference
	 * @model opposite="parentCompositeReference" containment="true" unsettable="true"
	 * @generated
	 */
	EList<TemplateDefinition> getTemplatesList();

	/**
	 * Unsets the value of the '{@link org.ow2.mindEd.adl.ComponentReference#getTemplatesList <em>Templates List</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetTemplatesList()
	 * @see #getTemplatesList()
	 * @generated
	 */
	void unsetTemplatesList();

	/**
	 * Returns whether the value of the '{@link org.ow2.mindEd.adl.ComponentReference#getTemplatesList <em>Templates List</em>}' containment reference list is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Templates List</em>' containment reference list is set.
	 * @see #unsetTemplatesList()
	 * @see #getTemplatesList()
	 * @generated
	 */
	boolean isSetTemplatesList();

	/**
	 * Returns the value of the '<em><b>Arguments List</b></em>' containment reference list.
	 * The list contents are of type {@link org.ow2.mindEd.adl.ArgumentDefinition}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Arguments List</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Arguments List</em>' containment reference list.
	 * @see #isSetArgumentsList()
	 * @see #unsetArgumentsList()
	 * @see org.ow2.mindEd.adl.AdlPackage#getComponentReference_ArgumentsList()
	 * @model containment="true" unsettable="true"
	 * @generated
	 */
	EList<ArgumentDefinition> getArgumentsList();

	/**
	 * Unsets the value of the '{@link org.ow2.mindEd.adl.ComponentReference#getArgumentsList <em>Arguments List</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetArgumentsList()
	 * @see #getArgumentsList()
	 * @generated
	 */
	void unsetArgumentsList();

	/**
	 * Returns whether the value of the '{@link org.ow2.mindEd.adl.ComponentReference#getArgumentsList <em>Arguments List</em>}' containment reference list is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Arguments List</em>' containment reference list is set.
	 * @see #unsetArgumentsList()
	 * @see #getArgumentsList()
	 * @generated
	 */
	boolean isSetArgumentsList();

	/**
	 * Returns the value of the '<em><b>Name FQN</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name FQN</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name FQN</em>' attribute.
	 * @see #setNameFQN(String)
	 * @see org.ow2.mindEd.adl.AdlPackage#getComponentReference_NameFQN()
	 * @model default="" transient="true" derived="true"
	 * @generated
	 */
	String getNameFQN();

	/**
	 * Sets the value of the '{@link org.ow2.mindEd.adl.ComponentReference#getNameFQN <em>Name FQN</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name FQN</em>' attribute.
	 * @see #getNameFQN()
	 * @generated
	 */
	void setNameFQN(String value);

	/**
	 * Returns the value of the '<em><b>Resolved</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resolved</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resolved</em>' attribute.
	 * @see #setResolved(boolean)
	 * @see org.ow2.mindEd.adl.AdlPackage#getComponentReference_Resolved()
	 * @model default="false" transient="true"
	 * @generated
	 */
	boolean isResolved();

	/**
	 * Sets the value of the '{@link org.ow2.mindEd.adl.ComponentReference#isResolved <em>Resolved</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Resolved</em>' attribute.
	 * @see #isResolved()
	 * @generated
	 */
	void setResolved(boolean value);

	/**
	 * Returns the value of the '<em><b>Parent References List</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.ow2.mindEd.adl.ReferencesList#getReferences <em>References</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parent References List</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent References List</em>' container reference.
	 * @see #setParentReferencesList(ReferencesList)
	 * @see org.ow2.mindEd.adl.AdlPackage#getComponentReference_ParentReferencesList()
	 * @see org.ow2.mindEd.adl.ReferencesList#getReferences
	 * @model opposite="references"
	 * @generated
	 */
	ReferencesList getParentReferencesList();

	/**
	 * Sets the value of the '{@link org.ow2.mindEd.adl.ComponentReference#getParentReferencesList <em>Parent References List</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent References List</em>' container reference.
	 * @see #getParentReferencesList()
	 * @generated
	 */
	void setParentReferencesList(ReferencesList value);

	/**
	 * Returns the value of the '<em><b>Parent Sub Component</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.ow2.mindEd.adl.SubComponentDefinition#getReferenceDefinition <em>Reference Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parent Sub Component</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent Sub Component</em>' container reference.
	 * @see #setParentSubComponent(SubComponentDefinition)
	 * @see org.ow2.mindEd.adl.AdlPackage#getComponentReference_ParentSubComponent()
	 * @see org.ow2.mindEd.adl.SubComponentDefinition#getReferenceDefinition
	 * @model opposite="referenceDefinition"
	 * @generated
	 */
	SubComponentDefinition getParentSubComponent();

	/**
	 * Sets the value of the '{@link org.ow2.mindEd.adl.ComponentReference#getParentSubComponent <em>Parent Sub Component</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent Sub Component</em>' container reference.
	 * @see #getParentSubComponent()
	 * @generated
	 */
	void setParentSubComponent(SubComponentDefinition value);

} // ComponentReference
