package org.ow2.mindEd.adl.editor.graphic.ui.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class BindingDefinitionReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public BindingDefinitionReorientCommand(ReorientRelationshipRequest request) {
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == getElementToEdit() instanceof org.ow2.mindEd.adl.BindingDefinition) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof org.ow2.mindEd.adl.InterfaceDefinition && newEnd instanceof org.ow2.mindEd.adl.InterfaceDefinition)) {
			return false;
		}
		org.ow2.mindEd.adl.InterfaceDefinition target = getLink()
				.getInterfaceTarget();
		if (!(getLink().eContainer() instanceof org.ow2.mindEd.adl.Body)) {
			return false;
		}
		org.ow2.mindEd.adl.Body container = (org.ow2.mindEd.adl.Body) getLink()
				.eContainer();
		return org.ow2.mindEd.adl.editor.graphic.ui.edit.policies.MindBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistBindingDefinition_4003(container,
						getLink(), getNewSource(), target);
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof org.ow2.mindEd.adl.InterfaceDefinition && newEnd instanceof org.ow2.mindEd.adl.InterfaceDefinition)) {
			return false;
		}
		org.ow2.mindEd.adl.InterfaceDefinition source = getLink()
				.getInterfaceSource();
		if (!(getLink().eContainer() instanceof org.ow2.mindEd.adl.Body)) {
			return false;
		}
		org.ow2.mindEd.adl.Body container = (org.ow2.mindEd.adl.Body) getLink()
				.eContainer();
		return org.ow2.mindEd.adl.editor.graphic.ui.edit.policies.MindBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistBindingDefinition_4003(container,
						getLink(), source, getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getLink().setInterfaceSource(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getLink().setInterfaceTarget(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected org.ow2.mindEd.adl.BindingDefinition getLink() {
		return (org.ow2.mindEd.adl.BindingDefinition) getElementToEdit();
	}

	/**
	 * @generated
	 */
	protected org.ow2.mindEd.adl.InterfaceDefinition getOldSource() {
		return (org.ow2.mindEd.adl.InterfaceDefinition) oldEnd;
	}

	/**
	 * @generated
	 */
	protected org.ow2.mindEd.adl.InterfaceDefinition getNewSource() {
		return (org.ow2.mindEd.adl.InterfaceDefinition) newEnd;
	}

	/**
	 * @generated
	 */
	protected org.ow2.mindEd.adl.InterfaceDefinition getOldTarget() {
		return (org.ow2.mindEd.adl.InterfaceDefinition) oldEnd;
	}

	/**
	 * @generated
	 */
	protected org.ow2.mindEd.adl.InterfaceDefinition getNewTarget() {
		return (org.ow2.mindEd.adl.InterfaceDefinition) newEnd;
	}
}
