package org.ow2.mindEd.adl.editor.graphic.ui.edit.parts;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LayoutManager;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gef.DragTracker;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editparts.AbstractEditPart;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.editpolicies.ResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.AbstractBorderItemEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.GraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.figures.BorderedNodeFigure;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class InterfaceDefinitionEditPart extends AbstractBorderItemEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 3130;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public InterfaceDefinitionEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE,
				getPrimaryDragEditPolicy());
		installEditPolicy(
				EditPolicyRoles.SEMANTIC_ROLE,
				new org.ow2.mindEd.adl.editor.graphic.ui.edit.policies.InterfaceDefinitionItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);

		getMindProxy().createDefaultEditPolicies();
		removeEditPolicy(EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(
					org.eclipse.gef.EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new InterfaceDefinitionFigure();
	}

	/**
	 * @generated
	 */
	public InterfaceDefinitionFigure getPrimaryShape() {
		return (InterfaceDefinitionFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(org.eclipse.gef.EditPart childEditPart) {
		if (getMindProxy().addFixedChild(childEditPart))
			return true;
		if (childEditPart instanceof org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionNameEditPart) {
			((org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionNameEditPart) childEditPart)
					.setLabel(getPrimaryShape()
							.getFigureLabelInterfaceDefinitionName());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(org.eclipse.gef.EditPart childEditPart) {
		if (childEditPart instanceof org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionNameEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(org.eclipse.gef.EditPart childEditPart,
			int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(org.eclipse.gef.EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(15, 15);

		result.setDefaultSize(20, 10);
		return result;
	}

	/**
	 * @generated
	 */
	public EditPolicy getPrimaryDragEditPolicy() {
		EditPolicy result = super.getPrimaryDragEditPolicy();
		if (result instanceof ResizableEditPolicy) {
			ResizableEditPolicy ep = (ResizableEditPolicy) result;
			ep.setResizeDirections(PositionConstants.NONE);
		}
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		IFigure shape = getMindProxy().setupContentPane(nodeShape);
		if (shape != null)
			return shape;

		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public org.eclipse.gef.EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
				.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(org.ow2.mindEd.adl.editor.graphic.ui.providers.MindElementTypes.BindingDefinition_4003);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(
			IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart) {
			types.add(org.ow2.mindEd.adl.editor.graphic.ui.providers.MindElementTypes.BindingDefinition_4003);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == org.ow2.mindEd.adl.editor.graphic.ui.providers.MindElementTypes.BindingDefinition_4003) {
			types.add(org.ow2.mindEd.adl.editor.graphic.ui.providers.MindElementTypes.InterfaceDefinition_3130);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(org.ow2.mindEd.adl.editor.graphic.ui.providers.MindElementTypes.BindingDefinition_4003);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == org.ow2.mindEd.adl.editor.graphic.ui.providers.MindElementTypes.BindingDefinition_4003) {
			types.add(org.ow2.mindEd.adl.editor.graphic.ui.providers.MindElementTypes.InterfaceDefinition_3130);
		}
		return types;
	}

	/**
	 * @generated
	 */
	protected Color getMindBorderColor() {
		return getMindProxy().getMindBorderColor();
	}

	/**
	 * @generated
	 */
	protected Color getMindBackgroundColor() {
		return getMindProxy().getMindBackgroundColor();
	}

	/**
	 * @generated
	 */
	protected Dimension getMindPreferredSize() {
		return getMindProxy().getMindPreferredSize();
	}

	/**
	 * @generated
	 */
	public class InterfaceDefinitionFigure
			extends
			org.ow2.mindEd.adl.editor.graphic.ui.custom.figures.InterfaceDefinitionShape {

		/**
		 * @generated
		 */
		private org.ow2.mindEd.adl.editor.graphic.ui.custom.figures.LabelInterfaceDefinitionNameCustomFigure fFigureLabelInterfaceDefinitionName;
		/**
		 * @generated
		 */
		private org.ow2.mindEd.adl.editor.graphic.ui.custom.figures.InterfaceDefinitionShape fFigureInterfaceDefinitionFigure;

		/**
		 * @generated
		 */
		public InterfaceDefinitionFigure() {

			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			fFigureLabelInterfaceDefinitionName = new org.ow2.mindEd.adl.editor.graphic.ui.custom.figures.LabelInterfaceDefinitionNameCustomFigure();

			fFigureLabelInterfaceDefinitionName.setBorder(new MarginBorder(
					getMapMode().DPtoLP(15), getMapMode().DPtoLP(0),
					getMapMode().DPtoLP(0), getMapMode().DPtoLP(0)));

			this.add(fFigureLabelInterfaceDefinitionName);

		}

		/**
		 * @generated
		 */
		public org.ow2.mindEd.adl.editor.graphic.ui.custom.figures.LabelInterfaceDefinitionNameCustomFigure getFigureLabelInterfaceDefinitionName() {
			return fFigureLabelInterfaceDefinitionName;
		}

		/**
		 * @generated
		 */
		public org.ow2.mindEd.adl.editor.graphic.ui.custom.figures.InterfaceDefinitionShape getFigureInterfaceDefinitionFigure() {
			return fFigureInterfaceDefinitionFigure;
		}

	}

	/**
	 * @generated
	 */
	protected org.ow2.mindEd.adl.editor.graphic.ui.custom.edit.parts.proxy.MindProxy mindProxy = org.ow2.mindEd.adl.editor.graphic.ui.custom.edit.parts.proxy.MindProxyFactory.INSTANCE
			.createMindProxy(this, VISUAL_ID);

	/**
	 * @generated
	 */
	public org.ow2.mindEd.adl.editor.graphic.ui.custom.edit.parts.proxy.MindProxy getMindProxy() {
		return mindProxy;
	}

	/**
	 * @generated
	 */
	@Override
	protected void refreshBounds() {
		if (!getMindProxy().refreshBounds() && getParent() != null)
			super.refreshBounds();
	}

	/**
	 * @generated
	 */
	@Override
	public void refresh() {
		super.refresh();
		getMindProxy().refresh();
		refreshBounds();
	}

	/**
	 * @generated
	 */
	@Override
	public void activate() {
		super.activate();
		getMindProxy().activate();
	}

	/**
	 * @generated
	 */
	@Override
	public DragTracker getDragTracker(Request request) {
		DragTracker tracker = getMindProxy().getDragTracker(request);
		if (tracker == null)
			tracker = super.getDragTracker(request);
		return tracker;
	}

	@Override
	protected void handleNotificationEvent(Notification notification) {
		super.handleNotificationEvent(notification);
		getMindProxy().handleNotificationEvent(notification);
	}

	/**
	 * This method is extended to preserve interfaces figures
	 * 
	 * @see AbstractEditPart#reorderChild(EditPart,
	 *      int)
	 */
	@Override
	protected void reorderChild(org.eclipse.gef.EditPart child, int index) {
		if (org.ow2.mindEd.adl.editor.graphic.ui.custom.edit.parts.proxy.MindProxy
				.getMindProxyFor(child) instanceof org.ow2.mindEd.adl.editor.graphic.ui.custom.edit.parts.proxy.MindBodyProxy) {
			// Save the border item locator so that it does not get lost during
			// the remove and re-add. This is overridden from the parent class
			// so that the correct content pane is used.
			IFigure container = null;
			LayoutManager layout = null;
			HashMap<IFigure, org.ow2.mindEd.adl.editor.graphic.ui.custom.layouts.InterfaceBorderItemLocator> locators = new HashMap<IFigure, org.ow2.mindEd.adl.editor.graphic.ui.custom.layouts.InterfaceBorderItemLocator>();
			List<IFigure> interfaces = new ArrayList<IFigure>();

			if (getFigure() instanceof BorderedNodeFigure)
				container = ((BorderedNodeFigure) getFigure())
						.getBorderItemContainer();

			if (container != null) {
				layout = container.getLayoutManager();

				@SuppressWarnings("unchecked")
				List<org.eclipse.gef.EditPart> childChildren = child
						.getChildren();
				for (org.eclipse.gef.EditPart childChild : childChildren) {
					if (childChild instanceof InterfaceDefinitionEditPart) {
						IFigure interfaceFigure = ((InterfaceDefinitionEditPart) childChild)
								.getFigure();
						Object constraint = null;

						if (layout != null && interfaceFigure != null)
							constraint = layout.getConstraint(interfaceFigure);

						if (constraint != null
								&& constraint instanceof org.ow2.mindEd.adl.editor.graphic.ui.custom.layouts.InterfaceBorderItemLocator) {
							org.ow2.mindEd.adl.editor.graphic.ui.custom.layouts.InterfaceBorderItemLocator locator = (org.ow2.mindEd.adl.editor.graphic.ui.custom.layouts.InterfaceBorderItemLocator) constraint;
							// Save interface's figure and its locator
							interfaces.add(interfaceFigure);
							locators.put(interfaceFigure, locator);
						}
					}
				}
			}

			IFigure childFigure = ((GraphicalEditPart) child).getFigure();
			layout = getContentPaneFor((IGraphicalEditPart) child)
					.getLayoutManager();

			Object constraint = null;
			if (layout != null)
				constraint = layout.getConstraint(childFigure);

			super.reorderChild(child, index);

			setLayoutConstraint(child, childFigure, constraint);

			if (container != null) {
				// Interfaces figures must be restored            
				for (IFigure interfaceFigure : interfaces) {
					container.add(interfaceFigure,
							locators.get(interfaceFigure));
				}
			}

		} else {
			super.reorderChild(child, index);
		}
	}
}
