package org.ow2.mindEd.adl.editor.graphic.ui.navigator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gmf.runtime.emf.core.GMFEditingDomainFactory;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonContentProvider;

/**
 * @generated
 */
public class MindNavigatorContentProvider implements ICommonContentProvider {

	/**
	 * @generated
	 */
	private static final Object[] EMPTY_ARRAY = new Object[0];

	/**
	 * @generated
	 */
	private Viewer myViewer;

	/**
	 * @generated
	 */
	private AdapterFactoryEditingDomain myEditingDomain;

	/**
	 * @generated
	 */
	private WorkspaceSynchronizer myWorkspaceSynchronizer;

	/**
	 * @generated
	 */
	private Runnable myViewerRefreshRunnable;

	/**
	 * @generated
	 */
	@SuppressWarnings({ "unchecked", "serial", "rawtypes" })
	public MindNavigatorContentProvider() {
		TransactionalEditingDomain editingDomain = GMFEditingDomainFactory.INSTANCE
				.createEditingDomain();
		myEditingDomain = (AdapterFactoryEditingDomain) editingDomain;
		myEditingDomain.setResourceToReadOnlyMap(new HashMap() {
			public Object get(Object key) {
				if (!containsKey(key)) {
					put(key, Boolean.TRUE);
				}
				return super.get(key);
			}
		});
		myViewerRefreshRunnable = new Runnable() {
			public void run() {
				if (myViewer != null) {
					myViewer.refresh();
				}
			}
		};
		myWorkspaceSynchronizer = new WorkspaceSynchronizer(editingDomain,
				new WorkspaceSynchronizer.Delegate() {
					public void dispose() {
					}

					public boolean handleResourceChanged(final Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceDeleted(Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceMoved(Resource resource,
							final URI newURI) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}
				});
	}

	/**
	 * @generated
	 */
	public void dispose() {
		myWorkspaceSynchronizer.dispose();
		myWorkspaceSynchronizer = null;
		myViewerRefreshRunnable = null;
		myViewer = null;
		unloadAllResources();
		((TransactionalEditingDomain) myEditingDomain).dispose();
		myEditingDomain = null;
	}

	/**
	 * @generated
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		myViewer = viewer;
	}

	/**
	 * @generated
	 */
	void unloadAllResources() {
		for (Resource nextResource : myEditingDomain.getResourceSet()
				.getResources()) {
			nextResource.unload();
		}
	}

	/**
	 * @generated
	 */
	void asyncRefresh() {
		if (myViewer != null && !myViewer.getControl().isDisposed()) {
			myViewer.getControl().getDisplay()
					.asyncExec(myViewerRefreshRunnable);
		}
	}

	/**
	 * @generated
	 */
	public Object[] getElements(Object inputElement) {
		return getChildren(inputElement);
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof IFile) {
			IFile file = (IFile) parentElement;
			URI fileURI = URI.createPlatformResourceURI(file.getFullPath()
					.toString(), true);
			Resource resource = myEditingDomain.getResourceSet().getResource(
					fileURI, true);
			ArrayList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorItem> result = new ArrayList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorItem>();
			ArrayList<View> topViews = new ArrayList<View>(resource
					.getContents().size());
			for (EObject o : resource.getContents()) {
				if (o instanceof View) {
					topViews.add((View) o);
				}
			}
			result.addAll(createNavigatorItems(
					selectViewsByType(
							topViews,
							org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.MODEL_ID),
					file, false));
			return result.toArray();
		}

		if (parentElement instanceof org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup) {
			org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup group = (org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup) parentElement;
			return group.getChildren();
		}

		if (parentElement instanceof org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorItem) {
			org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorItem navigatorItem = (org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorItem) parentElement;
			if (navigatorItem.isLeaf() || !isOwnView(navigatorItem.getView())) {
				return EMPTY_ARRAY;
			}
			return getViewChildren(navigatorItem.getView(), parentElement);
		}

		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Object[] getViewChildren(View view, Object parentElement) {
		switch (org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
				.getVisualID(view)) {

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeAnnotationsListEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeAnnotationsListCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferenceEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferenceCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FileCEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InlineCodeCEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveFormalArgumentsListEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveFormalArgumentsListCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FormalArgumentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveBodyEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AttributeDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup incominglinks = new org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup(
					org.ow2.mindEd.adl.editor.graphic.ui.part.Messages.NavigatorGroupName_InterfaceDefinition_3130_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup outgoinglinks = new org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup(
					org.ow2.mindEd.adl.editor.graphic.ui.part.Messages.NavigatorGroupName_InterfaceDefinition_3130_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BindingDefinitionEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BindingDefinitionEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Diagram sv = (Diagram) view;
			org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup links = new org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup(
					org.ow2.mindEd.adl.editor.graphic.ui.part.Messages.NavigatorGroupName_AdlDefinition_1000_links,
					"icons/linksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeComponentDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveComponentDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ComponentTypeDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BindingDefinitionEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			if (!links.isEmpty()) {
				result.add(links);
			}
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationElementEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferencesListEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferencesListCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferenceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationElementEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentPrimitiveBodyEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AttributeDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubComponentEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubReferenceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentPrimitiveBodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedBodyEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionReferenceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierReferenceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataFileCEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataInlineCodeCEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubReferenceEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationElementEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ConstantValueEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionReferenceEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionReferenceCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionReferenceCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubComponentEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubReferenceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeAnnotationsListEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeAnnotationsListCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubComponentEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubReferenceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentPrimitiveBodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedBodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubReferenceEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeComponentDefinitionEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifiersListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeFormalArgumentsListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferencesListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeAnnotationsListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferenceEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferenceCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferenceCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeFormalArgumentsListEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeFormalArgumentsListCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FormalArgumentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferencesListEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferencesListCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferenceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BindingDefinitionEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup target = new org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup(
					org.ow2.mindEd.adl.editor.graphic.ui.part.Messages.NavigatorGroupName_BindingDefinition_4003_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup source = new org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorGroup(
					org.ow2.mindEd.adl.editor.graphic.ui.part.Messages.NavigatorGroupName_BindingDefinition_4003_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveAnnotationsListEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveAnnotationsListCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeBodyEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveComponentDefinitionEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveFormalArgumentsListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferencesListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveBodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveAnnotationsListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubReferenceEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubComponentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubComponentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubComponentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubComponentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubComponentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubComponentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferencesListEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferencesListCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferenceEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifiersListEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifiersListCompartmentEditPart.VISUAL_ID));
			connectedViews = getChildrenByType(
					connectedViews,
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}

		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ComponentTypeDefinitionEditPart.VISUAL_ID: {
			LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem> result = new LinkedList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem>();
			Node sv = (Node) view;
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferencesListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeBodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(
					Collections.singleton(sv),
					org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
							.getType(org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeAnnotationsListEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			return result.toArray();
		}
		}
		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksSourceByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeSource = nextEdge.getSource();
			if (type.equals(nextEdgeSource.getType())
					&& isOwnView(nextEdgeSource)) {
				result.add(nextEdgeSource);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksTargetByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeTarget = nextEdge.getTarget();
			if (type.equals(nextEdgeTarget.getType())
					&& isOwnView(nextEdgeTarget)) {
				result.add(nextEdgeTarget);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getOutgoingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getSourceEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getIncomingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getTargetEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getChildrenByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getChildren(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getDiagramLinksByType(
			Collection<Diagram> diagrams, String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (Diagram nextDiagram : diagrams) {
			result.addAll(selectViewsByType(nextDiagram.getEdges(), type));
		}
		return result;
	}

	// TODO refactor as static method
	/**
	 * @generated
	 */
	private Collection<View> selectViewsByType(Collection<View> views,
			String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (View nextView : views) {
			if (type.equals(nextView.getType()) && isOwnView(nextView)) {
				result.add(nextView);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.MODEL_ID
				.equals(org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
						.getModelID(view));
	}

	/**
	 * @generated
	 */
	private Collection<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorItem> createNavigatorItems(
			Collection<View> views, Object parent, boolean isLeafs) {
		ArrayList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorItem> result = new ArrayList<org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorItem>(
				views.size());
		for (View nextView : views) {
			result.add(new org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindNavigatorItem(
					nextView, parent, isLeafs));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public Object getParent(Object element) {
		if (element instanceof org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem) {
			org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem abstractNavigatorItem = (org.ow2.mindEd.adl.editor.graphic.ui.navigator.MindAbstractNavigatorItem) element;
			return abstractNavigatorItem.getParent();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean hasChildren(Object element) {
		return element instanceof IFile || getChildren(element).length > 0;
	}

}
