package org.ow2.mindEd.adl.editor.graphic.ui.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class MindVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "org.ow2.mindEd.adl.editor.graphic.ui/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.MODEL_ID
					.equals(view.getType())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				org.ow2.mindEd.adl.editor.graphic.ui.part.MindDiagramEditorPlugin
						.getInstance().logError(
								"Unable to parse view type as a visualID number: "
										+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAdlDefinition()
				.isSuperTypeOf(domainElement.eClass())
				&& isDiagram((org.ow2.mindEd.adl.AdlDefinition) domainElement)) {
			return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
				.getModelID(containerView);
		if (!org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.MODEL_ID
				.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getCompositeComponentDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeComponentDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getPrimitiveComponentDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveComponentDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getComponentTypeDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ComponentTypeDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeComponentDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getTemplateSpecifiersList().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifiersListEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getFormalArgumentsList().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeFormalArgumentsListEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getCompositeReferencesList().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferencesListEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getCompositeBody()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getBody()
					.isSuperTypeOf(domainElement.eClass())
					&& isBody_3143((org.ow2.mindEd.adl.Body) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotationsList()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeAnnotationsListEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveComponentDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getFormalArgumentsList().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveFormalArgumentsListEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getPrimitiveReferencesList().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferencesListEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getPrimitiveBody()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveBodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getBody()
					.isSuperTypeOf(domainElement.eClass())
					&& isBody_3143((org.ow2.mindEd.adl.Body) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotationsList()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveAnnotationsListEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ComponentTypeDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getTypeReferencesList()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferencesListEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getTypeBody()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeBodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getBody()
					.isSuperTypeOf(domainElement.eClass())
					&& isBody_3143((org.ow2.mindEd.adl.Body) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotationsList()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeAnnotationsListEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getTypeReferenceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierReferenceEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getInterfaceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubComponentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getCompositeReferenceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubReferenceEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getSubComponentCompositeBody().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getBody()
					.isSuperTypeOf(domainElement.eClass())
					&& isBody_3143((org.ow2.mindEd.adl.Body) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotationsList()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubReferenceEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getArgumentDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getTemplateDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getInterfaceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubComponentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getCompositeReferenceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubReferenceEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getSubComponentPrimitiveBody().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentPrimitiveBodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getBody()
					.isSuperTypeOf(domainElement.eClass())
					&& isBody_3143((org.ow2.mindEd.adl.Body) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotationsList()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubReferenceEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getArgumentDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentPrimitiveBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getImplementationDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getDataDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getAttributeDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AttributeDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getInterfaceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotationElement()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationElementEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationElementEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getConstantValue()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ConstantValueEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotation()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotationElement()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationElementEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubComponentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getCompositeReferenceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubReferenceEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getSubComponentCompositeBody().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getBody()
					.isSuperTypeOf(domainElement.eClass())
					&& isBody_3143((org.ow2.mindEd.adl.Body) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotationsList()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getSubComponentPrimitiveBody().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentPrimitiveBodyEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getTypeBody()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedBodyEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubReferenceEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getArgumentDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getTemplateDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getInterfaceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getImplementationDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getDataDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getAttributeDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AttributeDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getInterfaceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getInterfaceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifiersListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getTemplateSpecifier()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeFormalArgumentsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getFormalArgument()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FormalArgumentEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferencesListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getCompositeReferenceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferenceEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferenceCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getArgumentDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getTemplateDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getCompositeReferenceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionReferenceEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionReferenceCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getArgumentDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getTemplateDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getSubComponentDefinition().isSuperTypeOf(
							domainElement.eClass())
					&& isSubComponentDefinition_3131((org.ow2.mindEd.adl.SubComponentDefinition) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubComponentEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getSubComponentDefinition().isSuperTypeOf(
							domainElement.eClass())
					&& isSubComponentDefinition_3135((org.ow2.mindEd.adl.SubComponentDefinition) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubComponentEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getSubComponentDefinition().isSuperTypeOf(
							domainElement.eClass())
					&& isSubComponentDefinition_3153((org.ow2.mindEd.adl.SubComponentDefinition) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubComponentEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getSubComponentDefinition().isSuperTypeOf(
							domainElement.eClass())
					&& isSubComponentDefinition_3131((org.ow2.mindEd.adl.SubComponentDefinition) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubComponentEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getSubComponentDefinition().isSuperTypeOf(
							domainElement.eClass())
					&& isSubComponentDefinition_3135((org.ow2.mindEd.adl.SubComponentDefinition) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubComponentEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getSubComponentDefinition().isSuperTypeOf(
							domainElement.eClass())
					&& isSubComponentDefinition_3153((org.ow2.mindEd.adl.SubComponentDefinition) domainElement)) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubComponentEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getFileC()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FileCEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getInlineCodeC()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InlineCodeCEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getFileC()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataFileCEditPart.VISUAL_ID;
			}
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getInlineCodeC()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataInlineCodeCEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotation()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeAnnotationsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotation()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveFormalArgumentsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getFormalArgument()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FormalArgumentEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferencesListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getPrimitiveReferenceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferenceEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferenceCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getArgumentDefinition()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveAnnotationsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotation()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferencesListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE
					.getTypeReferenceDefinition().isSuperTypeOf(
							domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferenceEditPart.VISUAL_ID;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeAnnotationsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getAnnotation()
					.isSuperTypeOf(domainElement.eClass())) {
				return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
				.getModelID(containerView);
		if (!org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.MODEL_ID
				.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = org.ow2.mindEd.adl.editor.graphic.ui.part.MindVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AdlDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeComponentDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveComponentDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ComponentTypeDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeComponentDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeComponentDefinitionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifiersListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeFormalArgumentsListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferencesListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeAnnotationsListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveComponentDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveComponentDefinitionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveFormalArgumentsListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferencesListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveBodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveAnnotationsListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ComponentTypeDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ComponentTypeDefinitionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferencesListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeBodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeAnnotationsListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifiersListEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifiersListCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierReferenceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierReferenceEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierReferenceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeFormalArgumentsListEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeFormalArgumentsListCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FormalArgumentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FormalArgumentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferencesListEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferencesListCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferenceEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferenceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferenceCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionReferenceEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionReferenceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionReferenceCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubComponentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubComponentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubReferenceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubReferenceEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubReferenceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubComponentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubComponentNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubReferenceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentPrimitiveBodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubReferenceEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubReferenceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentPrimitiveBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentPrimitiveBodyCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AttributeDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.LabelImplementationTitleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FileCEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FileCNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InlineCodeCEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InlineCodeCNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.LabelDataDefinitionTitleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataFileCEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataFileCNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataInlineCodeCEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataInlineCodeCNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AttributeDefinitionEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AttributeDefinitionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationElementEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationElementEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationElementElementNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ConstantValueEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ConstantValueEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ConstantValueValueEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationElementEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubComponentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentDefinitionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubReferenceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentPrimitiveBodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedBodyEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubReferenceEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubReferenceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedBodyCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeAnnotationsListEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeAnnotationsListCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveFormalArgumentsListEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveFormalArgumentsListCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferencesListEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.LabelTitleReferencesListEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferencesListCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferenceEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferenceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferenceCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveBodyCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AttributeDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveAnnotationsListEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveAnnotationsListCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferencesListEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferencesListCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferenceEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferenceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeBodyEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeBodyCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InterfaceDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeAnnotationsListEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeAnnotationsListCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifiersListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateSpecifierEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeFormalArgumentsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FormalArgumentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferencesListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferenceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeReferenceCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionReferenceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionReferenceCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TemplateDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeBodyCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubComponentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubComponentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubComponentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubComponentCompositeBodyCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeSubComponentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveSubComponentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.UndefinedSubComponentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ImplementationDefinitionCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FileCEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.InlineCodeCEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataDefinitionCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataFileCEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.DataInlineCodeCEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.SubAnnotationsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.CompositeAnnotationsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveFormalArgumentsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.FormalArgumentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferencesListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferenceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveReferenceCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.ArgumentDefinitionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.PrimitiveAnnotationsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferencesListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeReferenceEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.TypeAnnotationsListCompartmentEditPart.VISUAL_ID:
			if (org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.AnnotationEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (org.ow2.mindEd.adl.AdlPackage.eINSTANCE.getBindingDefinition()
				.isSuperTypeOf(domainElement.eClass())) {
			return org.ow2.mindEd.adl.editor.graphic.ui.edit.parts.BindingDefinitionEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(org.ow2.mindEd.adl.AdlDefinition element) {
		return true;
	}

	/**
	 * @generated
	 */
	private static boolean isSubComponentDefinition_3131(
			org.ow2.mindEd.adl.SubComponentDefinition domainElement) {
		return org.ow2.mindEd.adl.editor.graphic.ui.custom.constraints.JavaConstraints
				.isCompositeSubComponent(domainElement);
	}

	/**
	 * @generated
	 */
	private static boolean isSubComponentDefinition_3135(
			org.ow2.mindEd.adl.SubComponentDefinition domainElement) {
		return org.ow2.mindEd.adl.editor.graphic.ui.custom.constraints.JavaConstraints
				.isPrimitiveSubComponent(domainElement);
	}

	/**
	 * @generated
	 */
	private static boolean isBody_3143(org.ow2.mindEd.adl.Body domainElement) {
		return false;
	}

	/**
	 * @generated
	 */
	private static boolean isSubComponentDefinition_3153(
			org.ow2.mindEd.adl.SubComponentDefinition domainElement) {
		return org.ow2.mindEd.adl.editor.graphic.ui.custom.constraints.JavaConstraints
				.isUndefinedSubComponent(domainElement);
	}

}
