/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.ow2.mindEd.adl.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.ow2.mindEd.adl.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class AdlFactoryImpl extends EFactoryImpl implements AdlFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static AdlFactory init() {
		try {
			AdlFactory theAdlFactory = (AdlFactory)EPackage.Registry.INSTANCE.getEFactory("http://org.ow2.mindEd/adl.ecore/0.2.0"); 
			if (theAdlFactory != null) {
				return theAdlFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new AdlFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdlFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case AdlPackage.ARCHITECTURE_DEFINITION: return (EObject)createArchitectureDefinition();
			case AdlPackage.ADL_DEFINITION: return (EObject)createAdlDefinition();
			case AdlPackage.ANNOTATION: return (EObject)createAnnotation();
			case AdlPackage.ANNOTATION_ELEMENT: return (EObject)createAnnotationElement();
			case AdlPackage.ANNOTATIONS_LIST: return (EObject)createAnnotationsList();
			case AdlPackage.ARGUMENT_DEFINITION: return (EObject)createArgumentDefinition();
			case AdlPackage.ATTRIBUTE_DEFINITION: return (EObject)createAttributeDefinition();
			case AdlPackage.BINDING_DEFINITION: return (EObject)createBindingDefinition();
			case AdlPackage.BODY: return (EObject)createBody();
			case AdlPackage.COMPONENT_REFERENCE: return (EObject)createComponentReference();
			case AdlPackage.COMPONENT_TYPE_DEFINITION: return (EObject)createComponentTypeDefinition();
			case AdlPackage.COMPOSITE_BODY: return (EObject)createCompositeBody();
			case AdlPackage.COMPOSITE_COMPONENT_DEFINITION: return (EObject)createCompositeComponentDefinition();
			case AdlPackage.COMPOSITE_REFERENCE_DEFINITION: return (EObject)createCompositeReferenceDefinition();
			case AdlPackage.COMPOSITE_REFERENCES_LIST: return (EObject)createCompositeReferencesList();
			case AdlPackage.CONSTANT_VALUE: return (EObject)createConstantValue();
			case AdlPackage.DATA_DEFINITION: return (EObject)createDataDefinition();
			case AdlPackage.ELEMENT_VALUE: return (EObject)createElementValue();
			case AdlPackage.ELEMENT_VALUE_ARRAY_INITIALIZER: return (EObject)createElementValueArrayInitializer();
			case AdlPackage.FILE_C: return (EObject)createFileC();
			case AdlPackage.FORMAL_ARGUMENT: return (EObject)createFormalArgument();
			case AdlPackage.FORMAL_ARGUMENTS_LIST: return (EObject)createFormalArgumentsList();
			case AdlPackage.IMPLEMENTATION_DEFINITION: return (EObject)createImplementationDefinition();
			case AdlPackage.IMPORT_DEFINITION: return (EObject)createImportDefinition();
			case AdlPackage.INLINE_CODE_C: return (EObject)createInlineCodeC();
			case AdlPackage.INTERFACE_DEFINITION: return (EObject)createInterfaceDefinition();
			case AdlPackage.PRIMITIVE_BODY: return (EObject)createPrimitiveBody();
			case AdlPackage.PRIMITIVE_COMPONENT_DEFINITION: return (EObject)createPrimitiveComponentDefinition();
			case AdlPackage.PRIMITIVE_REFERENCE_DEFINITION: return (EObject)createPrimitiveReferenceDefinition();
			case AdlPackage.PRIMITIVE_REFERENCES_LIST: return (EObject)createPrimitiveReferencesList();
			case AdlPackage.REFERENCES_LIST: return (EObject)createReferencesList();
			case AdlPackage.SUB_COMPONENT_COMPOSITE_BODY: return (EObject)createSubComponentCompositeBody();
			case AdlPackage.SUB_COMPONENT_DEFINITION: return (EObject)createSubComponentDefinition();
			case AdlPackage.SUB_COMPONENT_PRIMITIVE_BODY: return (EObject)createSubComponentPrimitiveBody();
			case AdlPackage.TEMPLATE_DEFINITION: return (EObject)createTemplateDefinition();
			case AdlPackage.TEMPLATE_SPECIFIER: return (EObject)createTemplateSpecifier();
			case AdlPackage.TEMPLATE_SPECIFIERS_LIST: return (EObject)createTemplateSpecifiersList();
			case AdlPackage.TYPE_BODY: return (EObject)createTypeBody();
			case AdlPackage.TYPE_REFERENCE_DEFINITION: return (EObject)createTypeReferenceDefinition();
			case AdlPackage.TYPE_REFERENCES_LIST: return (EObject)createTypeReferencesList();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case AdlPackage.ROLE:
				return createRoleFromString(eDataType, initialValue);
			case AdlPackage.COMPONENT_KIND:
				return createComponentKindFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case AdlPackage.ROLE:
				return convertRoleToString(eDataType, instanceValue);
			case AdlPackage.COMPONENT_KIND:
				return convertComponentKindToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ArchitectureDefinition createArchitectureDefinition() {
		ArchitectureDefinitionImpl architectureDefinition = new ArchitectureDefinitionImpl();
		return architectureDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdlDefinition createAdlDefinition() {
		AdlDefinitionImpl adlDefinition = new AdlDefinitionImpl();
		return adlDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Annotation createAnnotation() {
		AnnotationImpl annotation = new AnnotationImpl();
		return annotation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AnnotationElement createAnnotationElement() {
		AnnotationElementImpl annotationElement = new AnnotationElementImpl();
		return annotationElement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AnnotationsList createAnnotationsList() {
		AnnotationsListImpl annotationsList = new AnnotationsListImpl();
		return annotationsList;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ArgumentDefinition createArgumentDefinition() {
		ArgumentDefinitionImpl argumentDefinition = new ArgumentDefinitionImpl();
		return argumentDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AttributeDefinition createAttributeDefinition() {
		AttributeDefinitionImpl attributeDefinition = new AttributeDefinitionImpl();
		return attributeDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BindingDefinition createBindingDefinition() {
		BindingDefinitionImpl bindingDefinition = new BindingDefinitionImpl();
		return bindingDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Body createBody() {
		BodyImpl body = new BodyImpl();
		return body;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentReference createComponentReference() {
		ComponentReferenceImpl componentReference = new ComponentReferenceImpl();
		return componentReference;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentTypeDefinition createComponentTypeDefinition() {
		ComponentTypeDefinitionImpl componentTypeDefinition = new ComponentTypeDefinitionImpl();
		return componentTypeDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompositeBody createCompositeBody() {
		CompositeBodyImpl compositeBody = new CompositeBodyImpl();
		return compositeBody;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompositeComponentDefinition createCompositeComponentDefinition() {
		CompositeComponentDefinitionImpl compositeComponentDefinition = new CompositeComponentDefinitionImpl();
		return compositeComponentDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompositeReferenceDefinition createCompositeReferenceDefinition() {
		CompositeReferenceDefinitionImpl compositeReferenceDefinition = new CompositeReferenceDefinitionImpl();
		return compositeReferenceDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompositeReferencesList createCompositeReferencesList() {
		CompositeReferencesListImpl compositeReferencesList = new CompositeReferencesListImpl();
		return compositeReferencesList;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConstantValue createConstantValue() {
		ConstantValueImpl constantValue = new ConstantValueImpl();
		return constantValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataDefinition createDataDefinition() {
		DataDefinitionImpl dataDefinition = new DataDefinitionImpl();
		return dataDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ElementValue createElementValue() {
		ElementValueImpl elementValue = new ElementValueImpl();
		return elementValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ElementValueArrayInitializer createElementValueArrayInitializer() {
		ElementValueArrayInitializerImpl elementValueArrayInitializer = new ElementValueArrayInitializerImpl();
		return elementValueArrayInitializer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FileC createFileC() {
		FileCImpl fileC = new FileCImpl();
		return fileC;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FormalArgument createFormalArgument() {
		FormalArgumentImpl formalArgument = new FormalArgumentImpl();
		return formalArgument;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FormalArgumentsList createFormalArgumentsList() {
		FormalArgumentsListImpl formalArgumentsList = new FormalArgumentsListImpl();
		return formalArgumentsList;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ImplementationDefinition createImplementationDefinition() {
		ImplementationDefinitionImpl implementationDefinition = new ImplementationDefinitionImpl();
		return implementationDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ImportDefinition createImportDefinition() {
		ImportDefinitionImpl importDefinition = new ImportDefinitionImpl();
		return importDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InlineCodeC createInlineCodeC() {
		InlineCodeCImpl inlineCodeC = new InlineCodeCImpl();
		return inlineCodeC;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceDefinition createInterfaceDefinition() {
		InterfaceDefinitionImpl interfaceDefinition = new InterfaceDefinitionImpl();
		return interfaceDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PrimitiveBody createPrimitiveBody() {
		PrimitiveBodyImpl primitiveBody = new PrimitiveBodyImpl();
		return primitiveBody;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PrimitiveComponentDefinition createPrimitiveComponentDefinition() {
		PrimitiveComponentDefinitionImpl primitiveComponentDefinition = new PrimitiveComponentDefinitionImpl();
		return primitiveComponentDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PrimitiveReferenceDefinition createPrimitiveReferenceDefinition() {
		PrimitiveReferenceDefinitionImpl primitiveReferenceDefinition = new PrimitiveReferenceDefinitionImpl();
		return primitiveReferenceDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PrimitiveReferencesList createPrimitiveReferencesList() {
		PrimitiveReferencesListImpl primitiveReferencesList = new PrimitiveReferencesListImpl();
		return primitiveReferencesList;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ReferencesList createReferencesList() {
		ReferencesListImpl referencesList = new ReferencesListImpl();
		return referencesList;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SubComponentCompositeBody createSubComponentCompositeBody() {
		SubComponentCompositeBodyImpl subComponentCompositeBody = new SubComponentCompositeBodyImpl();
		return subComponentCompositeBody;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SubComponentDefinition createSubComponentDefinition() {
		SubComponentDefinitionImpl subComponentDefinition = new SubComponentDefinitionImpl();
		return subComponentDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SubComponentPrimitiveBody createSubComponentPrimitiveBody() {
		SubComponentPrimitiveBodyImpl subComponentPrimitiveBody = new SubComponentPrimitiveBodyImpl();
		return subComponentPrimitiveBody;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TemplateDefinition createTemplateDefinition() {
		TemplateDefinitionImpl templateDefinition = new TemplateDefinitionImpl();
		return templateDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TemplateSpecifier createTemplateSpecifier() {
		TemplateSpecifierImpl templateSpecifier = new TemplateSpecifierImpl();
		return templateSpecifier;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TemplateSpecifiersList createTemplateSpecifiersList() {
		TemplateSpecifiersListImpl templateSpecifiersList = new TemplateSpecifiersListImpl();
		return templateSpecifiersList;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TypeBody createTypeBody() {
		TypeBodyImpl typeBody = new TypeBodyImpl();
		return typeBody;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TypeReferenceDefinition createTypeReferenceDefinition() {
		TypeReferenceDefinitionImpl typeReferenceDefinition = new TypeReferenceDefinitionImpl();
		return typeReferenceDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TypeReferencesList createTypeReferencesList() {
		TypeReferencesListImpl typeReferencesList = new TypeReferencesListImpl();
		return typeReferencesList;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Role createRoleFromString(EDataType eDataType, String initialValue) {
		Role result = Role.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertRoleToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentKind createComponentKindFromString(EDataType eDataType, String initialValue) {
		ComponentKind result = ComponentKind.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertComponentKindToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdlPackage getAdlPackage() {
		return (AdlPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static AdlPackage getPackage() {
		return AdlPackage.eINSTANCE;
	}

} //AdlFactoryImpl
