/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.ow2.mindEd.adl.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.ow2.mindEd.adl.AdlFactory;
import org.ow2.mindEd.adl.AdlPackage;
import org.ow2.mindEd.adl.SubComponentDefinition;

/**
 * This is the item provider adapter for a {@link org.ow2.mindEd.adl.SubComponentDefinition} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class SubComponentDefinitionItemProvider
	extends CompositeDefinitionElementItemProvider
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SubComponentDefinitionItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
			addComponentKindPropertyDescriptor(object);
			addSimpleNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ArchitectureDefinition_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ArchitectureDefinition_name_feature", "_UI_ArchitectureDefinition_type"),
				 AdlPackage.Literals.ARCHITECTURE_DEFINITION__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Component Kind feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addComponentKindPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ArchitectureDefinition_componentKind_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ArchitectureDefinition_componentKind_feature", "_UI_ArchitectureDefinition_type"),
				 AdlPackage.Literals.ARCHITECTURE_DEFINITION__COMPONENT_KIND,
				 false,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Simple Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addSimpleNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_ArchitectureDefinition_simpleName_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_ArchitectureDefinition_simpleName_feature", "_UI_ArchitectureDefinition_type"),
				 AdlPackage.Literals.ARCHITECTURE_DEFINITION__SIMPLE_NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(AdlPackage.Literals.ARCHITECTURE_DEFINITION__BODY);
			childrenFeatures.add(AdlPackage.Literals.ARCHITECTURE_DEFINITION__REFERENCES_LIST);
			childrenFeatures.add(AdlPackage.Literals.SUB_COMPONENT_DEFINITION__REFERENCE_DEFINITION);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns SubComponentDefinition.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/SubComponentDefinition"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((SubComponentDefinition)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_SubComponentDefinition_type") :
			getString("_UI_SubComponentDefinition_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(SubComponentDefinition.class)) {
			case AdlPackage.SUB_COMPONENT_DEFINITION__NAME:
			case AdlPackage.SUB_COMPONENT_DEFINITION__NAME_FQN:
			case AdlPackage.SUB_COMPONENT_DEFINITION__COMPONENT_KIND:
			case AdlPackage.SUB_COMPONENT_DEFINITION__SIMPLE_NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case AdlPackage.SUB_COMPONENT_DEFINITION__BODY:
			case AdlPackage.SUB_COMPONENT_DEFINITION__REFERENCES_LIST:
			case AdlPackage.SUB_COMPONENT_DEFINITION__REFERENCE_DEFINITION:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.ARCHITECTURE_DEFINITION__BODY,
				 AdlFactory.eINSTANCE.createBody()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.ARCHITECTURE_DEFINITION__BODY,
				 AdlFactory.eINSTANCE.createCompositeBody()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.ARCHITECTURE_DEFINITION__BODY,
				 AdlFactory.eINSTANCE.createPrimitiveBody()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.ARCHITECTURE_DEFINITION__BODY,
				 AdlFactory.eINSTANCE.createSubComponentCompositeBody()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.ARCHITECTURE_DEFINITION__BODY,
				 AdlFactory.eINSTANCE.createSubComponentPrimitiveBody()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.ARCHITECTURE_DEFINITION__BODY,
				 AdlFactory.eINSTANCE.createTypeBody()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.ARCHITECTURE_DEFINITION__REFERENCES_LIST,
				 AdlFactory.eINSTANCE.createReferencesList()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.ARCHITECTURE_DEFINITION__REFERENCES_LIST,
				 AdlFactory.eINSTANCE.createCompositeReferencesList()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.ARCHITECTURE_DEFINITION__REFERENCES_LIST,
				 AdlFactory.eINSTANCE.createPrimitiveReferencesList()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.ARCHITECTURE_DEFINITION__REFERENCES_LIST,
				 AdlFactory.eINSTANCE.createTypeReferencesList()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.SUB_COMPONENT_DEFINITION__REFERENCE_DEFINITION,
				 AdlFactory.eINSTANCE.createComponentReference()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.SUB_COMPONENT_DEFINITION__REFERENCE_DEFINITION,
				 AdlFactory.eINSTANCE.createCompositeReferenceDefinition()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.SUB_COMPONENT_DEFINITION__REFERENCE_DEFINITION,
				 AdlFactory.eINSTANCE.createPrimitiveReferenceDefinition()));

		newChildDescriptors.add
			(createChildParameter
				(AdlPackage.Literals.SUB_COMPONENT_DEFINITION__REFERENCE_DEFINITION,
				 AdlFactory.eINSTANCE.createTypeReferenceDefinition()));
	}

}
