/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.ow2.mindEd.adl.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import org.ow2.mindEd.adl.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.ow2.mindEd.adl.AdlPackage
 * @generated
 */
public class AdlAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static AdlPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdlAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = AdlPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdlSwitch<Adapter> modelSwitch =
		new AdlSwitch<Adapter>() {
			@Override
			public Adapter caseArchitectureDefinition(ArchitectureDefinition object) {
				return createArchitectureDefinitionAdapter();
			}
			@Override
			public Adapter caseAdlDefinition(AdlDefinition object) {
				return createAdlDefinitionAdapter();
			}
			@Override
			public Adapter caseAnnotation(Annotation object) {
				return createAnnotationAdapter();
			}
			@Override
			public Adapter caseAnnotationElement(AnnotationElement object) {
				return createAnnotationElementAdapter();
			}
			@Override
			public Adapter caseAnnotationsList(AnnotationsList object) {
				return createAnnotationsListAdapter();
			}
			@Override
			public Adapter caseArgumentDefinition(ArgumentDefinition object) {
				return createArgumentDefinitionAdapter();
			}
			@Override
			public Adapter caseAttributeDefinition(AttributeDefinition object) {
				return createAttributeDefinitionAdapter();
			}
			@Override
			public Adapter caseBindingDefinition(BindingDefinition object) {
				return createBindingDefinitionAdapter();
			}
			@Override
			public Adapter caseBody(Body object) {
				return createBodyAdapter();
			}
			@Override
			public Adapter caseComponentReference(ComponentReference object) {
				return createComponentReferenceAdapter();
			}
			@Override
			public Adapter caseComponentTypeDefinition(ComponentTypeDefinition object) {
				return createComponentTypeDefinitionAdapter();
			}
			@Override
			public Adapter caseCompositeBody(CompositeBody object) {
				return createCompositeBodyAdapter();
			}
			@Override
			public Adapter caseCompositeComponentDefinition(CompositeComponentDefinition object) {
				return createCompositeComponentDefinitionAdapter();
			}
			@Override
			public Adapter caseCompositeDefinitionElement(CompositeDefinitionElement object) {
				return createCompositeDefinitionElementAdapter();
			}
			@Override
			public Adapter caseCompositeReferenceDefinition(CompositeReferenceDefinition object) {
				return createCompositeReferenceDefinitionAdapter();
			}
			@Override
			public Adapter caseCompositeReferencesList(CompositeReferencesList object) {
				return createCompositeReferencesListAdapter();
			}
			@Override
			public Adapter caseConstantValue(ConstantValue object) {
				return createConstantValueAdapter();
			}
			@Override
			public Adapter caseDataDefinition(DataDefinition object) {
				return createDataDefinitionAdapter();
			}
			@Override
			public Adapter caseElement(Element object) {
				return createElementAdapter();
			}
			@Override
			public Adapter caseElementValue(ElementValue object) {
				return createElementValueAdapter();
			}
			@Override
			public Adapter caseElementValueArrayInitializer(ElementValueArrayInitializer object) {
				return createElementValueArrayInitializerAdapter();
			}
			@Override
			public Adapter caseFileC(FileC object) {
				return createFileCAdapter();
			}
			@Override
			public Adapter caseFormalArgument(FormalArgument object) {
				return createFormalArgumentAdapter();
			}
			@Override
			public Adapter caseFormalArgumentsList(FormalArgumentsList object) {
				return createFormalArgumentsListAdapter();
			}
			@Override
			public Adapter caseImplementationDefinition(ImplementationDefinition object) {
				return createImplementationDefinitionAdapter();
			}
			@Override
			public Adapter caseImportDefinition(ImportDefinition object) {
				return createImportDefinitionAdapter();
			}
			@Override
			public Adapter caseInlineCodeC(InlineCodeC object) {
				return createInlineCodeCAdapter();
			}
			@Override
			public Adapter caseInterfaceDefinition(InterfaceDefinition object) {
				return createInterfaceDefinitionAdapter();
			}
			@Override
			public Adapter caseMergedObject(MergedObject object) {
				return createMergedObjectAdapter();
			}
			@Override
			public Adapter casePrimitiveBody(PrimitiveBody object) {
				return createPrimitiveBodyAdapter();
			}
			@Override
			public Adapter casePrimitiveComponentDefinition(PrimitiveComponentDefinition object) {
				return createPrimitiveComponentDefinitionAdapter();
			}
			@Override
			public Adapter casePrimitiveDefinitionElement(PrimitiveDefinitionElement object) {
				return createPrimitiveDefinitionElementAdapter();
			}
			@Override
			public Adapter casePrimitiveReferenceDefinition(PrimitiveReferenceDefinition object) {
				return createPrimitiveReferenceDefinitionAdapter();
			}
			@Override
			public Adapter casePrimitiveReferencesList(PrimitiveReferencesList object) {
				return createPrimitiveReferencesListAdapter();
			}
			@Override
			public Adapter caseReferencesList(ReferencesList object) {
				return createReferencesListAdapter();
			}
			@Override
			public Adapter caseSubComponentCompositeBody(SubComponentCompositeBody object) {
				return createSubComponentCompositeBodyAdapter();
			}
			@Override
			public Adapter caseSubComponentDefinition(SubComponentDefinition object) {
				return createSubComponentDefinitionAdapter();
			}
			@Override
			public Adapter caseSubComponentPrimitiveBody(SubComponentPrimitiveBody object) {
				return createSubComponentPrimitiveBodyAdapter();
			}
			@Override
			public Adapter caseTemplateDefinition(TemplateDefinition object) {
				return createTemplateDefinitionAdapter();
			}
			@Override
			public Adapter caseTemplateSpecifier(TemplateSpecifier object) {
				return createTemplateSpecifierAdapter();
			}
			@Override
			public Adapter caseTemplateSpecifiersList(TemplateSpecifiersList object) {
				return createTemplateSpecifiersListAdapter();
			}
			@Override
			public Adapter caseTypeBody(TypeBody object) {
				return createTypeBodyAdapter();
			}
			@Override
			public Adapter caseTypeDefinitionElement(TypeDefinitionElement object) {
				return createTypeDefinitionElementAdapter();
			}
			@Override
			public Adapter caseTypeReferenceDefinition(TypeReferenceDefinition object) {
				return createTypeReferenceDefinitionAdapter();
			}
			@Override
			public Adapter caseTypeReferencesList(TypeReferencesList object) {
				return createTypeReferencesListAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.ArchitectureDefinition <em>Architecture Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.ArchitectureDefinition
	 * @generated
	 */
	public Adapter createArchitectureDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.AdlDefinition <em>Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.AdlDefinition
	 * @generated
	 */
	public Adapter createAdlDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.Annotation <em>Annotation</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.Annotation
	 * @generated
	 */
	public Adapter createAnnotationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.AnnotationElement <em>Annotation Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.AnnotationElement
	 * @generated
	 */
	public Adapter createAnnotationElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.AnnotationsList <em>Annotations List</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.AnnotationsList
	 * @generated
	 */
	public Adapter createAnnotationsListAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.ArgumentDefinition <em>Argument Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.ArgumentDefinition
	 * @generated
	 */
	public Adapter createArgumentDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.AttributeDefinition <em>Attribute Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.AttributeDefinition
	 * @generated
	 */
	public Adapter createAttributeDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.BindingDefinition <em>Binding Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.BindingDefinition
	 * @generated
	 */
	public Adapter createBindingDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.Body <em>Body</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.Body
	 * @generated
	 */
	public Adapter createBodyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.ComponentReference <em>Component Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.ComponentReference
	 * @generated
	 */
	public Adapter createComponentReferenceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.ComponentTypeDefinition <em>Component Type Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.ComponentTypeDefinition
	 * @generated
	 */
	public Adapter createComponentTypeDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.CompositeBody <em>Composite Body</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.CompositeBody
	 * @generated
	 */
	public Adapter createCompositeBodyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.CompositeComponentDefinition <em>Composite Component Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.CompositeComponentDefinition
	 * @generated
	 */
	public Adapter createCompositeComponentDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.CompositeDefinitionElement <em>Composite Definition Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.CompositeDefinitionElement
	 * @generated
	 */
	public Adapter createCompositeDefinitionElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.CompositeReferenceDefinition <em>Composite Reference Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.CompositeReferenceDefinition
	 * @generated
	 */
	public Adapter createCompositeReferenceDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.CompositeReferencesList <em>Composite References List</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.CompositeReferencesList
	 * @generated
	 */
	public Adapter createCompositeReferencesListAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.ConstantValue <em>Constant Value</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.ConstantValue
	 * @generated
	 */
	public Adapter createConstantValueAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.DataDefinition <em>Data Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.DataDefinition
	 * @generated
	 */
	public Adapter createDataDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.Element <em>Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.Element
	 * @generated
	 */
	public Adapter createElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.ElementValue <em>Element Value</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.ElementValue
	 * @generated
	 */
	public Adapter createElementValueAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.ElementValueArrayInitializer <em>Element Value Array Initializer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.ElementValueArrayInitializer
	 * @generated
	 */
	public Adapter createElementValueArrayInitializerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.FileC <em>File C</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.FileC
	 * @generated
	 */
	public Adapter createFileCAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.FormalArgument <em>Formal Argument</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.FormalArgument
	 * @generated
	 */
	public Adapter createFormalArgumentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.FormalArgumentsList <em>Formal Arguments List</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.FormalArgumentsList
	 * @generated
	 */
	public Adapter createFormalArgumentsListAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.ImplementationDefinition <em>Implementation Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.ImplementationDefinition
	 * @generated
	 */
	public Adapter createImplementationDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.ImportDefinition <em>Import Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.ImportDefinition
	 * @generated
	 */
	public Adapter createImportDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.InlineCodeC <em>Inline Code C</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.InlineCodeC
	 * @generated
	 */
	public Adapter createInlineCodeCAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.InterfaceDefinition <em>Interface Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.InterfaceDefinition
	 * @generated
	 */
	public Adapter createInterfaceDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.MergedObject <em>Merged Object</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.MergedObject
	 * @generated
	 */
	public Adapter createMergedObjectAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.PrimitiveBody <em>Primitive Body</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.PrimitiveBody
	 * @generated
	 */
	public Adapter createPrimitiveBodyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.PrimitiveComponentDefinition <em>Primitive Component Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.PrimitiveComponentDefinition
	 * @generated
	 */
	public Adapter createPrimitiveComponentDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.PrimitiveDefinitionElement <em>Primitive Definition Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.PrimitiveDefinitionElement
	 * @generated
	 */
	public Adapter createPrimitiveDefinitionElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.PrimitiveReferenceDefinition <em>Primitive Reference Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.PrimitiveReferenceDefinition
	 * @generated
	 */
	public Adapter createPrimitiveReferenceDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.PrimitiveReferencesList <em>Primitive References List</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.PrimitiveReferencesList
	 * @generated
	 */
	public Adapter createPrimitiveReferencesListAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.ReferencesList <em>References List</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.ReferencesList
	 * @generated
	 */
	public Adapter createReferencesListAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.SubComponentCompositeBody <em>Sub Component Composite Body</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.SubComponentCompositeBody
	 * @generated
	 */
	public Adapter createSubComponentCompositeBodyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.SubComponentDefinition <em>Sub Component Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.SubComponentDefinition
	 * @generated
	 */
	public Adapter createSubComponentDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.SubComponentPrimitiveBody <em>Sub Component Primitive Body</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.SubComponentPrimitiveBody
	 * @generated
	 */
	public Adapter createSubComponentPrimitiveBodyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.TemplateDefinition <em>Template Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.TemplateDefinition
	 * @generated
	 */
	public Adapter createTemplateDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.TemplateSpecifier <em>Template Specifier</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.TemplateSpecifier
	 * @generated
	 */
	public Adapter createTemplateSpecifierAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.TemplateSpecifiersList <em>Template Specifiers List</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.TemplateSpecifiersList
	 * @generated
	 */
	public Adapter createTemplateSpecifiersListAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.TypeBody <em>Type Body</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.TypeBody
	 * @generated
	 */
	public Adapter createTypeBodyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.TypeDefinitionElement <em>Type Definition Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.TypeDefinitionElement
	 * @generated
	 */
	public Adapter createTypeDefinitionElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.TypeReferenceDefinition <em>Type Reference Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.TypeReferenceDefinition
	 * @generated
	 */
	public Adapter createTypeReferenceDefinitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.ow2.mindEd.adl.TypeReferencesList <em>Type References List</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.ow2.mindEd.adl.TypeReferencesList
	 * @generated
	 */
	public Adapter createTypeReferencesListAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //AdlAdapterFactory
