/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.ow2.mindEd.adl.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.ow2.mindEd.adl.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.ow2.mindEd.adl.AdlPackage
 * @generated
 */
public class AdlSwitch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static AdlPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdlSwitch() {
		if (modelPackage == null) {
			modelPackage = AdlPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case AdlPackage.ARCHITECTURE_DEFINITION: {
				ArchitectureDefinition architectureDefinition = (ArchitectureDefinition)theEObject;
				T result = caseArchitectureDefinition(architectureDefinition);
				if (result == null) result = caseMergedObject(architectureDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.ADL_DEFINITION: {
				AdlDefinition adlDefinition = (AdlDefinition)theEObject;
				T result = caseAdlDefinition(adlDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.ANNOTATION: {
				Annotation annotation = (Annotation)theEObject;
				T result = caseAnnotation(annotation);
				if (result == null) result = caseElementValue(annotation);
				if (result == null) result = caseMergedObject(annotation);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.ANNOTATION_ELEMENT: {
				AnnotationElement annotationElement = (AnnotationElement)theEObject;
				T result = caseAnnotationElement(annotationElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.ANNOTATIONS_LIST: {
				AnnotationsList annotationsList = (AnnotationsList)theEObject;
				T result = caseAnnotationsList(annotationsList);
				if (result == null) result = caseMergedObject(annotationsList);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.ARGUMENT_DEFINITION: {
				ArgumentDefinition argumentDefinition = (ArgumentDefinition)theEObject;
				T result = caseArgumentDefinition(argumentDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.ATTRIBUTE_DEFINITION: {
				AttributeDefinition attributeDefinition = (AttributeDefinition)theEObject;
				T result = caseAttributeDefinition(attributeDefinition);
				if (result == null) result = casePrimitiveDefinitionElement(attributeDefinition);
				if (result == null) result = caseElement(attributeDefinition);
				if (result == null) result = caseMergedObject(attributeDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.BINDING_DEFINITION: {
				BindingDefinition bindingDefinition = (BindingDefinition)theEObject;
				T result = caseBindingDefinition(bindingDefinition);
				if (result == null) result = caseCompositeDefinitionElement(bindingDefinition);
				if (result == null) result = caseElement(bindingDefinition);
				if (result == null) result = caseMergedObject(bindingDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.BODY: {
				Body body = (Body)theEObject;
				T result = caseBody(body);
				if (result == null) result = caseMergedObject(body);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.COMPONENT_REFERENCE: {
				ComponentReference componentReference = (ComponentReference)theEObject;
				T result = caseComponentReference(componentReference);
				if (result == null) result = caseMergedObject(componentReference);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.COMPONENT_TYPE_DEFINITION: {
				ComponentTypeDefinition componentTypeDefinition = (ComponentTypeDefinition)theEObject;
				T result = caseComponentTypeDefinition(componentTypeDefinition);
				if (result == null) result = caseArchitectureDefinition(componentTypeDefinition);
				if (result == null) result = caseMergedObject(componentTypeDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.COMPOSITE_BODY: {
				CompositeBody compositeBody = (CompositeBody)theEObject;
				T result = caseCompositeBody(compositeBody);
				if (result == null) result = caseBody(compositeBody);
				if (result == null) result = caseMergedObject(compositeBody);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.COMPOSITE_COMPONENT_DEFINITION: {
				CompositeComponentDefinition compositeComponentDefinition = (CompositeComponentDefinition)theEObject;
				T result = caseCompositeComponentDefinition(compositeComponentDefinition);
				if (result == null) result = caseArchitectureDefinition(compositeComponentDefinition);
				if (result == null) result = caseMergedObject(compositeComponentDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.COMPOSITE_DEFINITION_ELEMENT: {
				CompositeDefinitionElement compositeDefinitionElement = (CompositeDefinitionElement)theEObject;
				T result = caseCompositeDefinitionElement(compositeDefinitionElement);
				if (result == null) result = caseElement(compositeDefinitionElement);
				if (result == null) result = caseMergedObject(compositeDefinitionElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.COMPOSITE_REFERENCE_DEFINITION: {
				CompositeReferenceDefinition compositeReferenceDefinition = (CompositeReferenceDefinition)theEObject;
				T result = caseCompositeReferenceDefinition(compositeReferenceDefinition);
				if (result == null) result = caseComponentReference(compositeReferenceDefinition);
				if (result == null) result = caseMergedObject(compositeReferenceDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.COMPOSITE_REFERENCES_LIST: {
				CompositeReferencesList compositeReferencesList = (CompositeReferencesList)theEObject;
				T result = caseCompositeReferencesList(compositeReferencesList);
				if (result == null) result = caseReferencesList(compositeReferencesList);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.CONSTANT_VALUE: {
				ConstantValue constantValue = (ConstantValue)theEObject;
				T result = caseConstantValue(constantValue);
				if (result == null) result = caseElementValue(constantValue);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.DATA_DEFINITION: {
				DataDefinition dataDefinition = (DataDefinition)theEObject;
				T result = caseDataDefinition(dataDefinition);
				if (result == null) result = casePrimitiveDefinitionElement(dataDefinition);
				if (result == null) result = caseElement(dataDefinition);
				if (result == null) result = caseMergedObject(dataDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.ELEMENT: {
				Element element = (Element)theEObject;
				T result = caseElement(element);
				if (result == null) result = caseMergedObject(element);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.ELEMENT_VALUE: {
				ElementValue elementValue = (ElementValue)theEObject;
				T result = caseElementValue(elementValue);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.ELEMENT_VALUE_ARRAY_INITIALIZER: {
				ElementValueArrayInitializer elementValueArrayInitializer = (ElementValueArrayInitializer)theEObject;
				T result = caseElementValueArrayInitializer(elementValueArrayInitializer);
				if (result == null) result = caseElementValue(elementValueArrayInitializer);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.FILE_C: {
				FileC fileC = (FileC)theEObject;
				T result = caseFileC(fileC);
				if (result == null) result = caseMergedObject(fileC);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.FORMAL_ARGUMENT: {
				FormalArgument formalArgument = (FormalArgument)theEObject;
				T result = caseFormalArgument(formalArgument);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.FORMAL_ARGUMENTS_LIST: {
				FormalArgumentsList formalArgumentsList = (FormalArgumentsList)theEObject;
				T result = caseFormalArgumentsList(formalArgumentsList);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.IMPLEMENTATION_DEFINITION: {
				ImplementationDefinition implementationDefinition = (ImplementationDefinition)theEObject;
				T result = caseImplementationDefinition(implementationDefinition);
				if (result == null) result = casePrimitiveDefinitionElement(implementationDefinition);
				if (result == null) result = caseElement(implementationDefinition);
				if (result == null) result = caseMergedObject(implementationDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.IMPORT_DEFINITION: {
				ImportDefinition importDefinition = (ImportDefinition)theEObject;
				T result = caseImportDefinition(importDefinition);
				if (result == null) result = caseMergedObject(importDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.INLINE_CODE_C: {
				InlineCodeC inlineCodeC = (InlineCodeC)theEObject;
				T result = caseInlineCodeC(inlineCodeC);
				if (result == null) result = caseMergedObject(inlineCodeC);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.INTERFACE_DEFINITION: {
				InterfaceDefinition interfaceDefinition = (InterfaceDefinition)theEObject;
				T result = caseInterfaceDefinition(interfaceDefinition);
				if (result == null) result = caseCompositeDefinitionElement(interfaceDefinition);
				if (result == null) result = casePrimitiveDefinitionElement(interfaceDefinition);
				if (result == null) result = caseTypeDefinitionElement(interfaceDefinition);
				if (result == null) result = caseElement(interfaceDefinition);
				if (result == null) result = caseMergedObject(interfaceDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.MERGED_OBJECT: {
				MergedObject mergedObject = (MergedObject)theEObject;
				T result = caseMergedObject(mergedObject);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.PRIMITIVE_BODY: {
				PrimitiveBody primitiveBody = (PrimitiveBody)theEObject;
				T result = casePrimitiveBody(primitiveBody);
				if (result == null) result = caseBody(primitiveBody);
				if (result == null) result = caseMergedObject(primitiveBody);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.PRIMITIVE_COMPONENT_DEFINITION: {
				PrimitiveComponentDefinition primitiveComponentDefinition = (PrimitiveComponentDefinition)theEObject;
				T result = casePrimitiveComponentDefinition(primitiveComponentDefinition);
				if (result == null) result = caseArchitectureDefinition(primitiveComponentDefinition);
				if (result == null) result = caseMergedObject(primitiveComponentDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.PRIMITIVE_DEFINITION_ELEMENT: {
				PrimitiveDefinitionElement primitiveDefinitionElement = (PrimitiveDefinitionElement)theEObject;
				T result = casePrimitiveDefinitionElement(primitiveDefinitionElement);
				if (result == null) result = caseElement(primitiveDefinitionElement);
				if (result == null) result = caseMergedObject(primitiveDefinitionElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.PRIMITIVE_REFERENCE_DEFINITION: {
				PrimitiveReferenceDefinition primitiveReferenceDefinition = (PrimitiveReferenceDefinition)theEObject;
				T result = casePrimitiveReferenceDefinition(primitiveReferenceDefinition);
				if (result == null) result = caseComponentReference(primitiveReferenceDefinition);
				if (result == null) result = caseMergedObject(primitiveReferenceDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.PRIMITIVE_REFERENCES_LIST: {
				PrimitiveReferencesList primitiveReferencesList = (PrimitiveReferencesList)theEObject;
				T result = casePrimitiveReferencesList(primitiveReferencesList);
				if (result == null) result = caseReferencesList(primitiveReferencesList);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.REFERENCES_LIST: {
				ReferencesList referencesList = (ReferencesList)theEObject;
				T result = caseReferencesList(referencesList);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.SUB_COMPONENT_COMPOSITE_BODY: {
				SubComponentCompositeBody subComponentCompositeBody = (SubComponentCompositeBody)theEObject;
				T result = caseSubComponentCompositeBody(subComponentCompositeBody);
				if (result == null) result = caseCompositeBody(subComponentCompositeBody);
				if (result == null) result = caseBody(subComponentCompositeBody);
				if (result == null) result = caseMergedObject(subComponentCompositeBody);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.SUB_COMPONENT_DEFINITION: {
				SubComponentDefinition subComponentDefinition = (SubComponentDefinition)theEObject;
				T result = caseSubComponentDefinition(subComponentDefinition);
				if (result == null) result = caseCompositeDefinitionElement(subComponentDefinition);
				if (result == null) result = caseArchitectureDefinition(subComponentDefinition);
				if (result == null) result = caseElement(subComponentDefinition);
				if (result == null) result = caseMergedObject(subComponentDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.SUB_COMPONENT_PRIMITIVE_BODY: {
				SubComponentPrimitiveBody subComponentPrimitiveBody = (SubComponentPrimitiveBody)theEObject;
				T result = caseSubComponentPrimitiveBody(subComponentPrimitiveBody);
				if (result == null) result = casePrimitiveBody(subComponentPrimitiveBody);
				if (result == null) result = caseBody(subComponentPrimitiveBody);
				if (result == null) result = caseMergedObject(subComponentPrimitiveBody);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.TEMPLATE_DEFINITION: {
				TemplateDefinition templateDefinition = (TemplateDefinition)theEObject;
				T result = caseTemplateDefinition(templateDefinition);
				if (result == null) result = caseTemplateSpecifier(templateDefinition);
				if (result == null) result = caseMergedObject(templateDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.TEMPLATE_SPECIFIER: {
				TemplateSpecifier templateSpecifier = (TemplateSpecifier)theEObject;
				T result = caseTemplateSpecifier(templateSpecifier);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.TEMPLATE_SPECIFIERS_LIST: {
				TemplateSpecifiersList templateSpecifiersList = (TemplateSpecifiersList)theEObject;
				T result = caseTemplateSpecifiersList(templateSpecifiersList);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.TYPE_BODY: {
				TypeBody typeBody = (TypeBody)theEObject;
				T result = caseTypeBody(typeBody);
				if (result == null) result = caseBody(typeBody);
				if (result == null) result = caseMergedObject(typeBody);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.TYPE_DEFINITION_ELEMENT: {
				TypeDefinitionElement typeDefinitionElement = (TypeDefinitionElement)theEObject;
				T result = caseTypeDefinitionElement(typeDefinitionElement);
				if (result == null) result = caseElement(typeDefinitionElement);
				if (result == null) result = caseMergedObject(typeDefinitionElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.TYPE_REFERENCE_DEFINITION: {
				TypeReferenceDefinition typeReferenceDefinition = (TypeReferenceDefinition)theEObject;
				T result = caseTypeReferenceDefinition(typeReferenceDefinition);
				if (result == null) result = caseComponentReference(typeReferenceDefinition);
				if (result == null) result = caseMergedObject(typeReferenceDefinition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case AdlPackage.TYPE_REFERENCES_LIST: {
				TypeReferencesList typeReferencesList = (TypeReferencesList)theEObject;
				T result = caseTypeReferencesList(typeReferencesList);
				if (result == null) result = caseReferencesList(typeReferencesList);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Architecture Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Architecture Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseArchitectureDefinition(ArchitectureDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAdlDefinition(AdlDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Annotation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Annotation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAnnotation(Annotation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Annotation Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Annotation Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAnnotationElement(AnnotationElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Annotations List</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Annotations List</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAnnotationsList(AnnotationsList object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Argument Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Argument Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseArgumentDefinition(ArgumentDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Attribute Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Attribute Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAttributeDefinition(AttributeDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Binding Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Binding Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBindingDefinition(BindingDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Body</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Body</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBody(Body object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Component Reference</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Component Reference</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseComponentReference(ComponentReference object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Component Type Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Component Type Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseComponentTypeDefinition(ComponentTypeDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Composite Body</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Composite Body</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCompositeBody(CompositeBody object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Composite Component Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Composite Component Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCompositeComponentDefinition(CompositeComponentDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Composite Definition Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Composite Definition Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCompositeDefinitionElement(CompositeDefinitionElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Composite Reference Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Composite Reference Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCompositeReferenceDefinition(CompositeReferenceDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Composite References List</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Composite References List</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCompositeReferencesList(CompositeReferencesList object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Constant Value</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Constant Value</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseConstantValue(ConstantValue object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Data Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Data Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDataDefinition(DataDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseElement(Element object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Element Value</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Element Value</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseElementValue(ElementValue object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Element Value Array Initializer</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Element Value Array Initializer</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseElementValueArrayInitializer(ElementValueArrayInitializer object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>File C</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>File C</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFileC(FileC object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Formal Argument</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Formal Argument</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFormalArgument(FormalArgument object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Formal Arguments List</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Formal Arguments List</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFormalArgumentsList(FormalArgumentsList object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Implementation Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Implementation Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseImplementationDefinition(ImplementationDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Import Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Import Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseImportDefinition(ImportDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Inline Code C</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Inline Code C</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInlineCodeC(InlineCodeC object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Interface Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Interface Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInterfaceDefinition(InterfaceDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Merged Object</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Merged Object</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMergedObject(MergedObject object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Primitive Body</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Primitive Body</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePrimitiveBody(PrimitiveBody object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Primitive Component Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Primitive Component Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePrimitiveComponentDefinition(PrimitiveComponentDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Primitive Definition Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Primitive Definition Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePrimitiveDefinitionElement(PrimitiveDefinitionElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Primitive Reference Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Primitive Reference Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePrimitiveReferenceDefinition(PrimitiveReferenceDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Primitive References List</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Primitive References List</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePrimitiveReferencesList(PrimitiveReferencesList object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>References List</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>References List</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseReferencesList(ReferencesList object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sub Component Composite Body</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sub Component Composite Body</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSubComponentCompositeBody(SubComponentCompositeBody object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sub Component Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sub Component Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSubComponentDefinition(SubComponentDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Sub Component Primitive Body</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Sub Component Primitive Body</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSubComponentPrimitiveBody(SubComponentPrimitiveBody object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Template Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Template Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTemplateDefinition(TemplateDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Template Specifier</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Template Specifier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTemplateSpecifier(TemplateSpecifier object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Template Specifiers List</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Template Specifiers List</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTemplateSpecifiersList(TemplateSpecifiersList object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Type Body</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Type Body</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTypeBody(TypeBody object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Type Definition Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Type Definition Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTypeDefinitionElement(TypeDefinitionElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Type Reference Definition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Type Reference Definition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTypeReferenceDefinition(TypeReferenceDefinition object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Type References List</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Type References List</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTypeReferencesList(TypeReferencesList object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //AdlSwitch
